
{-| Functions operating on terms. -}
module TypeChecker.Terms where

import Data.Generics

import Syntax.Internal

import TypeChecker.Monad
import TypeChecker.Values
import {-# SOURCE #-} TypeChecker.Computation	-- REMOVE_IF_HADDOCK

import Utils.Map
import Utils.Monads
import Utils.Debug
import Utils.Pairs

{- REMOVE_IF_HADDOCK

-- | Haddock phantom definition. Look at 'TypeChecker.Compuation.evaluateTypedTerm'
--   for the real one.
evaluateTypedTerm :: TypedTerm -> TC Value
evaluateTypedTerm = undefined

   REMOVE_IF_HADDOCK -}

-- | Get the type of a type annotated term.
termType :: TypedTerm -> TC Type
termType e = valueType <$> evaluateTypedTerm e

