-- Formalisation of set theory (exercise in Reiner's ATP course)
-- Author :: Ulf Norell
-- Created:: 2004-12-16

-- # import Property

-- Our domain (of sets)
D : Set

-- membership
infix 12 <-
(<-) : D -> D -> Prop

-- subset
infix 12 <=
(<=) : D -> D -> Prop
A <= B = (x:D) -> (x <- A) ==> (x <- B)

-- equality
infix 12 ==
(==) : D -> D -> Prop
A == B = A <= B /\ B <= A

-- a simple proof
propSubsetMember : (A,B:D) -> (x:D) -> A == B /\ x <- A ==> x <- B
propSubsetMember = fol-plugin()

