
-- # import Property

D : Set
(<=)  : D -> D -> Prop
(\./) : D -> D -> D

(==) : D -> D -> Prop
x == y = x <= y /\ y <= x

infix 5 ==
infix 6 <=
infix 7 \./

ax1 : (x : D) -> x <= x
ax2 : (x : D) -> (y : D) -> (z : D) ->
	  x \./ y <= z	    <=>
	  x <= z /\ y <= z

thm : (x,y,z,w : D) ->
	  x \./ y == z \./ w
	  <=>	x <= z \./ w
	    /\	y <= z \./ w
	    /\	z <= x \./ y
	    /\	w <= x \./ y
thm x y z w = fol-plugin(ax1, ax2)

