
-- # import id

infixr 15 ++,::

data List (A:Set) : Set where
  nil  : List A
  (::) :  A -> List A -> List A

data Elem {A:Set} : A -> List A -> Set where
  elemHead (x:A)(xs:List A)   : Elem x (x::xs)
  elemTail (x,y:A)(xs:List A) : Elem x xs -> Elem x (y::xs)

elemEmpty (C:Set)(A:Set)(x : A) : Elem x [] -> C

elemSingleton (A:Set)(x,y:A) : Elem x [y] -> x == y
elemSingleton elemHead	   = refl
elemSingleton (elemTail e) = elemEmpty e

(++) (A:Set) : List A -> List A -> List A
[]      ++ ys = ys
(x::xs) ++ ys = x :: (xs ++ ys)

