
-- # import Property

D : Set
Rel : (D : Set) -> Type
Rel D = D -> D -> Prop

W : D -> Rel D -> Rel D
W a R x y = R x y \/ (R x a /\ R a y)

TN : Rel D -> D -> Prop
TN R a = (x:D) -> (y:D) -> R x a ==> R a y ==> R x y

test : (a:D) -> (b:D) -> (R:Rel D) ->
        (x:D) -> (y:D) -> W b (W a R) x y <=> W a (W b R) x y
test a b R x y = fol-plugin()

{-
lem1 : (a:D) -> (R:Rel D) -> TN (W a R) a
--lem1 a R x y h1 h2 = fol-plugin(h1,h2)
lem1 a R = fol-plugin()

lem2 : (a:D) -> (b:D) -> (R:Rel D) -> TN R b ==> TN (W a R) b
--lem2 a b R h1 x y h2 h3 = fol-plugin(h1,h2,h3)
lem2 a b R = fol-plugin()

inclus : Rel D -> Rel D -> Prop
inclus R S = (x:D) -> (y:D) -> R x y ==> S x y

lem3 : (R:Rel D) -> (S:Rel D) -> (a:D) ->
        inclus R S ==> TN S a ==> inclus (W a R) S
--lem3 R S a h1 h2 x y h3 = fol-plugin(h1,h2,h3)
lem3 R S a = fol-plugin()

lem4 : (a:D) -> (R:Rel D) ->
        (x:D) -> (y:D) -> W a (W a R) x y <=> W a R x y
lem4 a R x y = fol-plugin()

lem5 : (a:D) -> (R:Rel D) -> inclus R (W a R)
lem5 a R x y h1 = fol-plugin(h1)
-}
