
data (==) {A:Set}(a:A) : A -> Set where
  refl : a == a

infix 2 ==

sym (A : Set)(x, y : A) : x == y -> y == x
sym refl = refl

trans (A : Set)(x, z : A) : (y : A) -> x == y -> y == z -> x == z
trans _ refl eq = eq

subst (A : Set)(x, y : A) : (P : A -> Set) -> x == y -> P x -> P y
subst P refl px = px

cong (A, B : Set)(x, y : A) : (f : A -> B) -> x == y -> f x == f y
cong f refl = refl

